"use strict";
var credential_descriptor_1 = require("./credential-descriptor");
var guid_1 = require("./guid");
var BaseServiceRequest = (function () {
    function BaseServiceRequest(options) {
        this.id = guid_1.Guid.newGuid();
        this.ts = Date.now();
        this.options = { result: true, timeout: 30000, simulate: false };
        this.credentials = credential_descriptor_1.ANONYMOUS;
    }
    BaseServiceRequest.wrap = function (data) {
        var req = new BaseServiceRequest(data.options);
        req.id = data.id || req.id;
        req.ts = data.ts || req.ts;
        req.group = data.group;
        req.action = data.action;
        req.target = data.target;
        req.service = data.service;
        req.credentials = data.credentials;
        req.payload = data.payload;
        return req;
    };
    BaseServiceRequest.prototype.toCapabilityQuery = function () {
        return {
            group: this.group,
            target: this.target,
            action: this.action
        };
    };
    return BaseServiceRequest;
}());
exports.BaseServiceRequest = BaseServiceRequest;

//# sourceMappingURL=base-service-request.js.map
