import { Platform } from "../platform";
import { CapabilityQuery } from "../capability-query";
import { ServiceProxy } from "../service-proxy";
import * as P from "bluebird";
import { ServiceRequest } from "../service-request";
import { connection as WebSocketConnection } from "websocket";
import { ServiceResponse } from "../service-response";
import { ServiceExecutionPlan } from "../service-execution-plan";
export interface StreamPlatformOptions {
    secure?: boolean;
    version?: number;
}
export declare class StreamPlatformClient implements Platform {
    private host;
    private port;
    private options;
    private socket;
    private logger;
    private conn;
    private connResolver;
    private connRejecter;
    private protocolHandler;
    private responseHandlers;
    constructor(host: string, port: number, options: StreamPlatformOptions);
    initialize(): void;
    protected handleConnectionError(error: Error): void;
    protected connection(): P<WebSocketConnection>;
    private registerResponseHandler(conn, request);
    private removeResponseHandler(request);
    resolveService(query: CapabilityQuery): P<ServiceProxy>;
    send(request: ServiceRequest): void;
    exec(request: ServiceRequest): P<ServiceResponse>;
    broadcast(request: ServiceRequest): P<any>;
    head(request: ServiceRequest): P<ServiceExecutionPlan>;
}
