"use strict";
var StreamServiceProxy = (function () {
    function StreamServiceProxy(platform, conn, proxySpec) {
        this.platform = platform;
        this.conn = conn;
        this.uuid = proxySpec.serviceId;
        this.spec = proxySpec;
    }
    StreamServiceProxy.prototype.exec = function (request) {
        // Enforce that this service is our target
        request.service = this.uuid;
        return this.platform.exec(request);
    };
    StreamServiceProxy.prototype.send = function (request) {
        // Enforce that this service is our target
        request.service = this.uuid;
        this.platform.send(request);
    };
    return StreamServiceProxy;
}());
exports.StreamServiceProxy = StreamServiceProxy;

//# sourceMappingURL=stream-service-proxy.js.map
