"use strict";
var P = require("bluebird");
var base_service_response_1 = require("../base-service-response");
var ResponseHandler = (function () {
    function ResponseHandler(conn, protocolHandler) {
        this.conn = conn;
        this.protocolHandler = protocolHandler;
    }
    ResponseHandler.prototype.waitForResponse = function (request) {
        var _this = this;
        var responsePromise = new P(function (resolve) {
            var h = function (msg) {
                console.log("Receive message", msg.type);
                // Disconnect our listener
                _this.conn.removeListener('message', h);
                if (msg.type === 'binary') {
                    console.log("Received binary message of len = ", msg.binaryData.length);
                    var response = _this.protocolHandler.decode(msg.binaryData);
                    resolve(new base_service_response_1.BaseServiceResponse(response));
                }
            };
            _this.conn.on('message', h);
        });
        // Install the timeout for this request
        responsePromise.timeout(request.options.timeout || 30000);
        return responsePromise;
    };
    return ResponseHandler;
}());
exports.ResponseHandler = ResponseHandler;

//# sourceMappingURL=response-handler.js.map
